class MochiAd
{
   function MochiAd()
   {
   }
   static function debug(s)
   {
      var _loc1_ = _root;
      if(typeof _loc1_._MochiAd_debugText == "undefined")
      {
         _loc1_._MochiAd_debugText = "";
      }
      _loc1_._MochiAd_debugText += s + "\n";
      trace("[MochiAd] " + s);
   }
   static function isNetworkAvailable()
   {
      if(System.security)
      {
         if(System.security.sandboxType == "localWithFile")
         {
            return false;
         }
      }
      return true;
   }
   static function showPreloaderAd(clip, options)
   {
      var _loc1_ = options;
      var _loc2_ = this;
      var optcopy = {};
      if(_loc1_)
      {
         for(var k in _loc1_)
         {
            optcopy[k] = _loc1_[k];
         }
      }
      _loc1_ = optcopy;
      var ad_msec = 6000;
      var ad_timeout = 2000;
      var fadeout_time = 250;
      if(!_loc1_)
      {
         _loc1_ = {};
      }
      if(typeof _loc1_.regpt == "undefined")
      {
         _loc1_.regpt = "o";
      }
      if(typeof _loc1_.method == "undefined")
      {
         _loc1_.method = "showPreloaderAd";
      }
      if(typeof _loc1_.ad_msec != "undefined")
      {
         ad_msec = _loc1_.ad_msec;
         delete _loc1_.ad_msec;
      }
      if(typeof _loc1_.ad_timeout != "undefined")
      {
         ad_timeout = _loc1_.ad_timeout;
         delete _loc1_.ad_timeout;
      }
      if(typeof _loc1_.fadeout_time != "undefined")
      {
         fadeout_time = _loc1_.fadeout_time;
         delete _loc1_.fadeout_time;
      }
      var success = MochiAd.load(clip,_loc1_);
      if(!success)
      {
         return false;
      }
      clip.stop();
      var mc = clip._mochiad;
      var b = clip.getBounds();
      var _loc3_ = 0;
      var h = 0;
      if(typeof _loc1_.res != "undefined")
      {
         var xy = _loc1_.res.split("x");
         _loc3_ = parseFloat(xy[0]);
         h = parseFloat(xy[1]);
      }
      else
      {
         _loc3_ = b.xMax - b.xMin;
         var h = b.yMax - b.yMin;
      }
      if(_loc3_ == 0 || h == 0)
      {
         _loc3_ = Stage.width;
         h = Stage.height;
      }
      mc._x = _loc3_ * 0.5;
      mc._y = h * 0.5;
      var chk = mc.createEmptyMovieClip("_mochiad_wait",3);
      chk._x = _loc3_ * -0.5;
      chk._y = h * -0.5;
      var bar = chk.createEmptyMovieClip("_mochiad_bar",4);
      bar._x = 10;
      bar._y = h - 20;
      var bar_color = 16747008;
      if(typeof _loc1_.color != "undefined")
      {
         bar_color = _loc1_.color;
         delete _loc1_.color;
      }
      var bar_background = 16777161;
      if(typeof _loc1_.background != "undefined")
      {
         bar_background = _loc1_.background;
         delete _loc1_.background;
      }
      var bar_outline = 13994812;
      if(typeof _loc1_.outline != "undefined")
      {
         bar_outline = _loc1_.outline;
         delete _loc1_.outline;
      }
      var backing = bar.createEmptyMovieClip("_outline",1);
      backing.beginFill(bar_background);
      backing.moveTo(0,0);
      backing.lineTo(_loc3_ - 20,0);
      backing.lineTo(_loc3_ - 20,10);
      backing.lineTo(0,10);
      backing.lineTo(0,0);
      backing.endFill();
      var inside = bar.createEmptyMovieClip("_inside",2);
      inside.beginFill(bar_color);
      inside.moveTo(0,0);
      inside.lineTo(_loc3_ - 20,0);
      inside.lineTo(_loc3_ - 20,10);
      inside.lineTo(0,10);
      inside.lineTo(0,0);
      inside.endFill();
      inside._xscale = 0;
      var outline = bar.createEmptyMovieClip("_outline",3);
      outline.lineStyle(0,bar_outline,100);
      outline.moveTo(0,0);
      outline.lineTo(_loc3_ - 20,0);
      outline.lineTo(_loc3_ - 20,10);
      outline.lineTo(0,10);
      outline.lineTo(0,0);
      chk.ad_msec = ad_msec;
      chk.ad_timeout = ad_timeout;
      chk.started = getTimer();
      chk.showing = false;
      chk.last_pcnt = 0;
      chk.fadeout_time = fadeout_time;
      chk.fadeFunction = function()
      {
         var _loc1_ = this;
         var _loc3_ = 100 * (1 - (getTimer() - _loc1_.fadeout_start) / _loc1_.fadeout_time);
         if(_loc3_ > 0)
         {
            _loc1_._parent._alpha = _loc3_;
         }
         else
         {
            var _loc2_ = _loc1_._parent._parent;
            MochiAd.unload(_loc2_);
            delete _loc1_.onEnterFrame;
            _loc2_.play();
         }
      };
      chk.onEnterFrame = function()
      {
         var _loc1_ = this;
         var clip = _loc1_._parent._parent;
         var ad_clip = _loc1_._parent._mochiad_ctr;
         var elapsed = getTimer() - _loc1_.started;
         var _loc3_ = false;
         var clip_total = clip.getBytesTotal();
         var clip_loaded = clip.getBytesLoaded();
         var clip_pcnt = 100 * clip_loaded / clip_total;
         var ad_pcnt = 100 * elapsed / chk.ad_msec;
         var inside = _loc1_._mochiad_bar._inside;
         var _loc2_ = Math.min(100,Math.min(clip_pcnt || 0,ad_pcnt));
         _loc2_ = Math.max(_loc1_.last_pcnt,_loc2_);
         _loc1_.last_pcnt = _loc2_;
         inside._xscale = _loc2_;
         if(!chk.showing)
         {
            var total = ad_clip.getBytesTotal();
            if(total > 0 || typeof total == "undefined")
            {
               chk.showing = true;
               chk.started = getTimer();
            }
            else if(elapsed > chk.ad_timeout)
            {
               _loc3_ = true;
            }
         }
         if(elapsed > chk.ad_msec)
         {
            _loc3_ = true;
         }
         if(clip_total > 0 && clip_loaded >= clip_total && _loc3_)
         {
            _loc1_.fadeout_start = getTimer();
            _loc1_.onEnterFrame = chk.fadeFunction;
         }
      };
   }
   static function showTimedAd(clip, options)
   {
      var _loc1_ = options;
      var _loc2_ = this;
      var _loc3_ = {};
      if(_loc1_)
      {
         for(var k in _loc1_)
         {
            _loc3_[k] = _loc1_[k];
         }
      }
      _loc1_ = _loc3_;
      var ad_msec = 6000;
      var ad_timeout = 2000;
      var fadeout_time = 250;
      if(!_loc1_)
      {
         _loc1_ = {};
      }
      if(typeof _loc1_.regpt == "undefined")
      {
         _loc1_.regpt = "o";
      }
      if(typeof _loc1_.method == "undefined")
      {
         _loc1_.method = "showTimedAd";
      }
      if(typeof _loc1_.ad_msec != "undefined")
      {
         ad_msec = _loc1_.ad_msec;
         delete _loc1_.ad_msec;
      }
      if(typeof _loc1_.ad_timeout != "undefined")
      {
         ad_timeout = _loc1_.ad_timeout;
         delete _loc1_.ad_timeout;
      }
      if(typeof _loc1_.fadeout_time != "undefined")
      {
         fadeout_time = _loc1_.fadeout_time;
         delete _loc1_.fadeout_time;
      }
      var success = MochiAd.load(clip,_loc1_);
      if(!success)
      {
         return false;
      }
      clip.stop();
      var mc = clip._mochiad;
      var b = clip.getBounds();
      var w = 0;
      var h = 0;
      if(typeof _loc1_.res != "undefined")
      {
         var xy = _loc1_.res.split("x");
         w = parseFloat(xy[0]);
         h = parseFloat(xy[1]);
      }
      else
      {
         var w = b.xMax - b.xMin;
         var h = b.yMax - b.yMin;
      }
      if(w == 0 || h == 0)
      {
         w = Stage.width;
         h = Stage.height;
      }
      mc._x = w * 0.5;
      mc._y = h * 0.5;
      var chk = mc.createEmptyMovieClip("_mochiad_wait",3);
      chk.ad_msec = ad_msec;
      chk.ad_timeout = ad_timeout;
      chk.started = getTimer();
      chk.showing = false;
      chk.fadeout_time = fadeout_time;
      chk.fadeFunction = function()
      {
         var _loc1_ = this;
         var _loc3_ = 100 * (1 - (getTimer() - _loc1_.fadeout_start) / _loc1_.fadeout_time);
         if(_loc3_ > 0)
         {
            _loc1_._parent._alpha = _loc3_;
         }
         else
         {
            var _loc2_ = _loc1_._parent._parent;
            MochiAd.unload(_loc2_);
            delete _loc1_.onEnterFrame;
            _loc2_.play();
         }
      };
      chk.onEnterFrame = function()
      {
         var _loc1_ = this;
         var clip = _loc1_._parent._parent;
         var ad_clip = _loc1_._parent._mochiad_ctr;
         var elapsed = getTimer() - _loc1_.started;
         var _loc2_ = false;
         if(!chk.showing)
         {
            var _loc3_ = ad_clip.getBytesTotal();
            if(_loc3_ > 0 || typeof _loc3_ == "undefined")
            {
               chk.showing = true;
               chk.started = getTimer();
            }
            else if(elapsed > chk.ad_timeout)
            {
               _loc2_ = true;
            }
         }
         if(elapsed > chk.ad_msec)
         {
            _loc2_ = true;
         }
         if(_loc2_)
         {
            _loc1_.fadeout_start = getTimer();
            _loc1_.onEnterFrame = _loc1_.fadeFunction;
         }
      };
   }
   static function load(clip, options)
   {
      var _loc1_ = options;
      var optcopy = {};
      if(_loc1_)
      {
         for(var k in _loc1_)
         {
            optcopy[k] = _loc1_[k];
         }
      }
      _loc1_ = optcopy;
      if(typeof clip == "undefined")
      {
         clip = _root;
      }
      if(!MochiAd.isNetworkAvailable())
      {
         return false;
      }
      var MOCHIADS_SERVER = "http://x.mochiads.com/srv/1/";
      var no_menu = false;
      if(clip._mochiad_loaded)
      {
         return false;
      }
      var depth = 10333;
      if(_loc1_.depth)
      {
         depth = _loc1_.depth;
         delete _loc1_.depth;
      }
      var mc = clip.createEmptyMovieClip("_mochiad",depth);
      if(!_loc1_)
      {
         _loc1_ = {};
      }
      if(typeof _loc1_.id == "undefined")
      {
         _loc1_.id = "_UNKNOWN_";
      }
      if(typeof _loc1_.server == "undefined")
      {
         _loc1_.server = MOCHIADS_SERVER;
      }
      if(typeof _loc1_.res == "undefined")
      {
         var b = clip.getBounds();
         var w = Math.floor(b.xMax - b.xMin);
         var h = Math.floor(b.yMax - b.yMin);
         if(w == 0 || h == 0)
         {
            w = Stage.width;
            h = Stage.height;
         }
         _loc1_.res = w + "x" + h;
      }
      _loc1_.server += _loc1_.id;
      delete _loc1_.id;
      if(_loc1_.no_menu)
      {
         no_menu = true;
         delete _loc1_.no_menu;
      }
      clip._mochiad_loaded = true;
      var lv = mc.createEmptyMovieClip("_mochiad_ctr",1);
      for(var k in _loc1_)
      {
         lv[k] = _loc1_[k];
      }
      if(clip._url.indexOf("http") != 0)
      {
         _loc1_.no_page = true;
      }
      if(!no_menu)
      {
         var murl = _loc1_.server + "/";
         var MENU_ITEMS = [["MochiAds : Sponsor this game","sponsor"],["MochiAds : Learn more","about"]];
         var menu = new ContextMenu();
         menu.hideBuiltInItems();
         var _loc2_ = 0;
         while(_loc2_ < MENU_ITEMS.length)
         {
            var _loc3_ = MENU_ITEMS[_loc2_];
            var fn = function(clickURL)
            {
               var _loc1_ = function()
               {
                  getURL(clickURL,"_blank");
               };
               return _loc1_;
            };
            var item = new ContextMenuItem(_loc3_[0],fn(murl + _loc3_[1]));
            menu.customItems.push(item);
            _loc2_ = _loc2_ + 1;
         }
         _root.menu = menu;
      }
      var server = lv.server;
      delete lv.server;
      var hostname = server.split("/")[2].split(":")[0];
      if(System.security)
      {
         if(System.security.allowDomain)
         {
            System.security.allowDomain(hostname);
         }
         if(System.security.allowInsecureDomain)
         {
            System.security.allowInsecureDomain(hostname);
         }
      }
      lv.st = getTimer();
      lv.loadMovie(server + ".swf","POST");
      return true;
   }
   static function unload(clip)
   {
      var _loc1_ = clip;
      if(typeof _loc1_ == "undefined")
      {
         _loc1_ = _root;
      }
      if(!_loc1_._mochiad)
      {
         return false;
      }
      _loc1_._mochiad.removeMovieClip();
      delete _loc1_._mochiad_loaded;
      delete _loc1_._mochiad;
      return true;
   }
   static function main(mc)
   {
      var _loc1_ = mc;
      if(typeof _loc1_ == "undefined")
      {
         _loc1_ = _root;
      }
      MochiAd.showTimedAd(_loc1_,{id:"test"});
   }
}
